Subject: bug#19609: coreutils tests on illumos

From: Pádraig Brady <[email-masked]>
Date: Mon, 19 Jan 2015 13:52:34 +0000

tag 19609 notabug
close 19609
stop

On 15/01/15 18:05, Alexander Pyhalov wrote:
> Hello.
> I was looking at coreutils test suite on illumos.
> There are currently about 5 failing tests.
> 
> First are 2 df tests. They assume that struct mntent *getmntent (FILE 
> *fp) is used by df. But it's not true on SystemV. Instead, int getmntent 
> (FILE *fp, struct mnttab *mp) is used. Patches to correct tests on 
> illumos is here:
> https://github.com/OpenIndiana/oi-userland/blob/oi/hipster/components/coreutils/patches/tests_df_no-mtab-status.sh.patch
> https://github.com/OpenIndiana/oi-userland/blob/oi/hipster/components/coreutils/patches/tests_df_skip-duplicates.sh.patch

The above are already addressed in v8.23 with:
http://git.sv.gnu.org/gitweb/?p=coreutils.git;a=commitdiff;h=39e2a4cf

> 3 remaining failing tests are from glib-tests directory.
> 
> First one is test-locale.c. It assumes that LC_GLOBAL_LOCALE is a 
> constant. On illumos it's a function, so compilation fails. Fix is here: 
> https://github.com/OpenIndiana/oi-userland/blob/oi/hipster/components/coreutils/patches/gnulib-tests_test-locale.c.patch
> 
> Second is test-getlogin. It seems to be a bit strange: it compares $USER 
> and getlogin(). Under "su" they don't match, so it can occasionally fail.

There have been a few changes to that test in gnulib since
coreutils 8.21 was released, so I'm hopeful that's addressed too.

> Third (test-getlogin) is a bit tricky.

I presume you mean test-localename.c

> It uses gl_locale_name_thread_unsafe, which simply doesn't know about 
> illumos/Solaris and returns NULL, so the test fails. I don't have a fix 
> for this one.

I'll follow up on [email-masked]

thanks,
Pádraig